//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <io.h>
#pragma hdrstop

#include "gbwcnv1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_Main *Form_Main;
//---------------------------------------------------------------------------
__fastcall TForm_Main::TForm_Main(TComponent* Owner)
    : TForm(Owner)
{
    BaseData1=new BaseData();
    BaseData1->ReadStandard();

    Map = new MapData();
    for(int i=0;i<2;i++){
        SideStatus1[i] = new SideStatus(i);
        Purposes1[i] = new GamePurposes();
    }
    Situation = new GameSituation();
    GBWImage = new GBWImageData();
    GBWImage->ImageList_UnitN->Masked = false;
    GBWImage->ImageList_UnitS->Masked = false;
    GBWImage->Load(32);
}
//---------------------------------------------------------------------------
__fastcall TForm_Main::~TForm_Main()
{
    delete BaseData1;
    delete Map;
    for(int i=0;i<2;i++){
        delete SideStatus1[i];
        delete Purposes1[i];
    }
    delete Situation;
    delete GBWImage;
}
//---------------------------------------------------------------------------
void __fastcall TForm_Main::MenuItem_ConvertClick(TObject *Sender)
{
    if(OpenDialog_Convert->Execute()){
        Convert(OpenDialog_Convert->Files);
    }
}
//---------------------------------------------------------------------------
__fastcall TForm_Main::Convert(TStrings *files)
{
    char file[256],ext[4],msg[256];
    int len;

    for(int i=0;i<files->Count;i++){
        strcpy(file, files->Strings[i].c_str());
        len = strlen(file);
        if(len<4 || file[len-4]!='.')
            continue;
        strcpy(ext, &file[len-3]);
        sprintf(msg,"%s ... ",file);
        bool success=false;
        if(!stricmp(ext,"map")){
            if(LoadMap(file) != -1 &&
               SaveGame(file,true) != -1){
               success=true;
            }
        }
        else if(!stricmp(ext,"sav")){
            if(LoadGame(file) != -1 &&
               SaveGame(file,false) != -1){
               success=true;
            }
        }
        else if(!stricmp(ext,"uni")){
            if(BaseData1->ReadUser(file) != -1){
                file[len-3] = '\0';
                strcat(file,"csv");
                if(BaseData1->SaveToCSV(file) != -1){
                    success=true;
                }
            }
        }
        else if(!stricmp(ext,"bmp")){
            char str[256];
            sprintf(str,"%sɕWjbg̉摜܂߂܂H",file);
            if(MessageDlg(str, mtConfirmation,TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes)
                BaseData1->NoStandard = false;
            else
                BaseData1->NoStandard = true;
            if(ConvertBitmap(file) != -1){
                success=true;
            }
        }

        if(success){
            strcat(msg,"OK.");
        }else{
            strcat(msg,"failed.iɃRo[gς݁Hj");
        }
        Memo_Log->Lines->Append(msg);
    }
    return 0;
}
//---------------------------------------------------------------------------
/*// gbwedit1.cpp SaveMap(),LoadMap(),LoadMapBinary()
// eLXg`Ń}bvZ[uB
__fastcall TForm_Main::SaveMap(char *file)
{
    TDataTable *table = new TDataTable();
    char key[100];
    bool Error=false;
    int i,j,x,y;

    for(y=0;y<Map->Height;y++)
        for(x=0;x<Map->Width;x++){
            if(Map->Data[x][y].Graph%BUILDINGMAX > 12)
                Error=true; //gȂn``FbN
        }
    if(Error){
        ShowMessage("gpłȂn`܂܂Ă܂B\n~󂪕`ꂽn`͎g܂B");
        return -1;
    }

    table->SetCategory("Map property");
    table->Put(KEY_MAPVERSION,MAPVERNUMBER);
    Map->WriteTextCompact(table); //MapDataNX̓ei[

    //i[
    for(i=0;i<2;i++){
        sprintf(key,"%s%d",KEY_BEGINMONEY,i);
        table->Put(key,SideStatus1[i]->Money);
    }

    //zujbgi[
    for(i=0;i<2;i++){
        sprintf(key,"%s%d",CTG_UNITS,i);
        table->SetCategory(key);
        for(j=0; j<SideStatus1[i]->UnitCount; j++){
            sprintf(key,"%s%d",KEY_UNITTYPE,j);
            table->Put(key,SideStatus1[i]->Unit[j].Type);
            sprintf(key,"%s%d",KEY_UNITXY,j);
            table->PutTwoValues(key,SideStatus1[i]->Unit[j].X,
                                    SideStatus1[i]->Unit[j].Y);
        }
    }
    table->SaveToFile(file);
    delete table;
    return 0;
}*/
//---------------------------------------------------------------------------
// gbwedit1.cpp LoadMap(),LoadMapBinary()
__fastcall TForm_Main::LoadMap(char *file)
{
    TDataTable *table;
    char key[100],c;
    int handle,uType,uGraph,ux,uy,i,j;

    //o[W̃t@Cǂ𔻕
    handle=open(file,O_BINARY|O_RDONLY);
    if(handle==-1)
        return -1;
    read(handle,&c,1);
    close(handle);
    if(c != '[')
        return LoadMapBinary(file);

    table = new TDataTable();
    table->LoadFromFile(file);

    if(table->GetCategory("Save Property") != -1)
        return -1;

    for(i=0;i<=1;i++)
        SideStatus1[i]->Initialize();
    Map->Initialize();
    Map->ReadTextCompact(table); //MapDataNX̓eo

    //ǂ
    for(i=0;i<2;i++){
        sprintf(key,"%s%d",KEY_BEGINMONEY,i);
        table->Get(key,&SideStatus1[i]->Money);
    }

    //zujbgǂ
    for(i=0;i<2;i++){
        sprintf(key,"%s%d",CTG_UNITS,i);
        table->GetCategory(key);
        for(j=0; j<UNITMAX; j++){
            sprintf(key,"%s%d",KEY_UNITTYPE,j);
            if(table->Get(key,&uType) != -1){
                sprintf(key,"%s%d",KEY_UNITXY,j);
                table->GetTwoValues(key,&ux,&uy);
                uGraph = i*UNITTYPEMAX+uType;
                SideStatus1[i]->AddUnit(BaseData1,ux,uy,uGraph);
                SideStatus1[i]->Unit[j].Actioned=false;
                if(Map->Data[ux][uy].Side == -1){
                    Map->Data[ux][uy].Side=(char)i;
                    Map->Data[ux][uy].Unit=(char)j;
                }
                else{
                    SideStatus1[i]->LoadUnit(Map->Data[ux][uy].Unit,j);
                }
            }
            else
                break;
        }
        SideStatus1[i]->CalcIncome(Map,BaseData1);
    }
    delete table;
    return 0;
}
//---------------------------------------------------------------------------
// oCit@CǂށBȑÕo[Wi1.37܂ŁjMapLoad()֐B
__fastcall TForm_Main::LoadMapBinary(char *file)
{
    VersionControl Version1;
    char str[(sizeof MAPVERHEAD)];
    bool SetUnit,SetPurpose,UnitExtend,BeginMoney;
    short s;
    int handle,h,i,j,k,Graph,x,y,zx,zy,v1,v2;

    handle=open(file,O_BINARY|O_RDONLY);
    if(handle==-1)
        return -1;
    read(handle,str,(sizeof MAPVERHEAD)-1);
    str[(sizeof MAPVERHEAD)-1]='\0';
    if(strcmp(str,MAPVERHEAD)){
        ShowMessage("ǒn헪̃}bv`ł͂܂B\n");
        close(handle);
        return -1;
    }
    read(handle,str,VERSIONLENGTH+1);
    v1=Version1.StrToValue(str);
    v2=Version1.StrToValue(MAPVERSION);
    if(v1>v2){
        ShowMessage("}bv`̃o[WႢ܂B\n");
        close(handle);
        return -1;
    }

    for(i=0;i<=1;i++)
        SideStatus1[i]->Initialize();
    Map->Initialize();
    read(handle,Map->Name,sizeof Map->Name);
    read(handle,&Map->Width,sizeof Map->Width);
    read(handle,&Map->Height,sizeof Map->Height);
    if(v1<102){
        for(y=0;y<MAPHEIGHT_OLD;y++)
            for(x=0;x<MAPWIDTH_OLD;x++)
                read(handle,&Map->Data[x][y].Graph,1);
    }
    else
        for(y=0;y<Map->Height;y++)
            for(x=0;x<Map->Width;x++)
                read(handle,&Map->Data[x][y].Graph,1);

    i=read(handle,&SetUnit,sizeof SetUnit);
    if(i && (int)SetUnit==1)  //jbgzu
        for(i=0;i<2;i++){
            read(handle,&s,sizeof s);
            k=s;  //UnitCount
            if(v1<102) //1.01ȑOUnitCountɊւ炸萔Ă
                h=UNITMAX_OLD;
            else
                h=k;
            for(j=0;j<h;j++){
                read(handle,&s,sizeof s);
                Graph=i*UNITTYPEMAX+s;
                read(handle,&s,sizeof s);
                zx=s;
                read(handle,&s,sizeof s);
                zy=s;
                if(j<k){
                    SideStatus1[i]->AddUnit(BaseData1,zx,zy,Graph);
                    SideStatus1[i]->Unit[j].Actioned=false;
                    if(Map->Data[zx][zy].Side == -1){
                        Map->Data[zx][zy].Side=(char)i;
                        Map->Data[zx][zy].Unit=(char)j;
                    }
                    else{
                        SideStatus1[i]->LoadUnit(Map->Data[zx][zy].Unit,j);
                    }
                }
            }
        }

    i=read(handle,&SetPurpose,sizeof SetPurpose);
    if(i && SetPurpose) //BڕW
        for(i=0;i<2;i++)
            Purposes1[i]->Read(handle);
    else
        for(i=0;i<2;i++)
            Purposes1[i]->Initialize();

    i=read(handle,&UnitExtend,sizeof UnitExtend);
    if(i && UnitExtend) //jbgf[^
        read(handle,Map->UnitDataFile,sizeof Map->UnitDataFile);
    i=read(handle,&BeginMoney,sizeof BeginMoney);
    if(i && BeginMoney){ //
        read(handle,&SideStatus1[0]->Money,sizeof(int));
        read(handle,&SideStatus1[1]->Money,sizeof(int));
    }
    close(handle);

    if(v1<v2)  //o[Wt@C̃Ro[g
        Map->VersionConvert(v1);

    for(i=0;i<2;i++){
        SideStatus1[i]->CalcIncome(Map,BaseData1);
    }
    //SaveMap(file); [hɍŐVtH[}bgɂĂ悤B
    return 0;
}
//---------------------------------------------------------------------------
// gbw1.cpp SaveGame(),LoadGame(),LoadGameBinary()
// Ver.2̓}bvƋʂ̃tH[}bgB
__fastcall TForm_Main::SaveGame(char *file,bool mapMode)
{
    TDataTable *table = new TDataTable();
    char ctg[50];
    const int owner[3]={0,1,-1};
    int i,x,y;

    table->SetCategory(CTG_SAVEPROPERTY);
    table->Put(KEY_SAVEVERSION, SAVEVERNUMBER);

    if(!mapMode){
        table->SetCategory(CTG_SITUATION);
        Situation->WriteText(table);
    }
    table->SetCategory(CTG_MAPDATA);
    // Ver.2L[lႤ̂ŁAɒڃR[hB
    //Map->WriteText(table);
    table->Put(KEY_MAPWIDTH, Map->Width);
    table->Put(KEY_MAPHEIGHT, Map->Height);
    table->Put(KEY_MAPNAME, Map->Name);
    int len = strlen(Map->UnitDataFile);
    if(len >= 3){ // .uni.csvɕύXB
        Map->UnitDataFile[len-3] = '\0';
        strcat(Map->UnitDataFile,"csv");
    }
    table->Put(KEY_UNITFILE, Map->UnitDataFile);

    for(y=0;y<Map->Height;y++)
        for(x=0;x<Map->Width;x++){
            sprintf(ctg,"%s %d,%d",CTG_MAPSTATUS,x,y);
            table->SetCategory(ctg);
            int graph = Map->Data[x][y].Graph;
            if(graph < BUILDINGMAX*3){
                table->Put("ID", graph%BUILDINGMAX);
                table->Put("Owner", owner[graph/BUILDINGMAX]);
                if(mapMode && !(graph%BUILDINGMAX))
                    Map->Data[x][y].Life = 400;
                table->Put(KEY_MS_LIFE, Map->Data[x][y].Life);
            }else{
                table->Put("ID", graph);
            }
        }

    for(i=0;i<2;i++){
        // ID`ŏo͂邽߁B蔲B
        for(int num=0;num<SideStatus1[i]->UnitCount;num++){
            UnitStatus *unitp = &SideStatus1[i]->Unit[num];
            /*
            CtEREe𖞃^ɂ邽߂ɂ肽
            悭lƂBaseDataǂݍ܂ȂƖB
            UnitChip *unitInfop = &BaseData1->UnitInfo[unitp->Type];
            unitp->SetDefault(unitp->Graph,unitp->Type,unitInfop);
            */
            unitp->Ver2Mode = true;
        }
        sprintf(ctg,"%s%d",CTG_SIDESTATUS,i);
        table->SetCategory(ctg);
        SideStatus1[i]->WriteText(table);
    }

    table->SaveToFile(file);
    delete table;
    return 0;
}
//---------------------------------------------------------------------------
//Z[uf[^ǂݍŃQ[ĊJ
__fastcall TForm_Main::LoadGame(char *file)
{
    TDataTable *table;
    int handle,i;
    char str[100],c;

    handle = open(file,O_BINARY|O_RDONLY);
    if(handle==-1)
        return -1;
    read(handle,&c,1);
    close(handle);
    if(c != '['){   //eLXgt@CłȂꍇ
        if(LoadGameBinary(file) == -1)
            return -1;
    }
    else{
        Map->Initialize();
        table = new TDataTable();
        table->LoadFromFile(file);

        table->GetCategory(CTG_SITUATION);
        Situation->ReadText(table);

        table->GetSubCategory(CTG_MAPDATA);
        Map->ReadText(table);

        for(i=0;i<2;i++){
            sprintf(str,"%s%d",CTG_SIDESTATUS,i);
            table->GetSubCategory(str);
            SideStatus1[i]->ReadText(table);
        }
        delete table;
    }
    return 0;
}
//---------------------------------------------------------------------------
//oCĩZ[uf[^ǂށB
//ߋւ̌݊̂߂ɌÂR[hcĂ邾Ȃ̂
//ł邾ύXȂƁB
__fastcall TForm_Main::LoadGameBinary(char *file)
{
    VersionControl Version1;
    char str[100];
    int handle,i,v1,v2;

    handle=open(file,O_BINARY|O_RDONLY);
    if(handle==-1)
        return -1;
    read(handle,str,(sizeof SAVEVERHEAD)-1);
    str[(sizeof SAVEVERHEAD)-1]='\0';
    if(strcmp(str,SAVEVERHEAD)){
        ShowMessage("ǒn헪̃Z[u`ł͂܂B\n");
        close(handle);
        return -1;
    }
    read(handle,str,VERSIONLENGTH+1);
    v1=Version1.StrToValue(str);
    v2=Version1.StrToValue(SAVEVERSION);
    if(v1>v2){
        ShowMessage("Z[u`̃o[WႢ܂B\n");
        close(handle);
        return -1;
    }
    Map->Initialize();
    if(v1>=105){
        Map->Read(handle);  //}bv̏
        SideStatus1[0]->Read(handle);
        SideStatus1[1]->Read(handle);
        Situation->Read(handle);  //݂̏
    }
    else{
        Map->ReadVer104(handle);
        SideStatus1[0]->ReadVer104(handle);
        SideStatus1[1]->ReadVer104(handle);
        Situation->ReadVer104(handle);
    }
    for(i=0;i<2;i++)
        SideStatus1[i]->AdjustUnitFuel();
    if(v1>=103) //슄蓖Ă̏Ԃǂݍ
        read(handle, Situation->CPUMode, sizeof Situation->CPUMode);
    else
        Situation->CPUModeDefault();
    if(v1>=104){ //BڕWǂݍ
        for(i=0;i<2;i++)
            Purposes1[i]->Read(handle);
    }
    else
        for(i=0;i<2;i++)
            Purposes1[i]->Initialize();
    close(handle);
    if(v1<v2){
        if(v1<102)
            Map->VersionConvert(100);
        else if(v1<109)
            Map->VersionConvert(102);
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_Main::ConvertBitmap(char *file)
{
    const int sides=2;
    const int nw=32,nh=32,sw=16,sh=16;
    Graphics::TBitmap *bmp = new Graphics::TBitmap();
    TImageList *image_g_n = GBWImage->ImageList_MapN;
    TImageList *image_g_s = GBWImage->ImageList_MapS;
    TImageList *image_u_n = GBWImage->ImageList_UnitN;
    TImageList *image_u_s = GBWImage->ImageList_UnitS;
    int side,count,lines,num,currentY,nx,ny,sx,sy;

    if(access(file,0))
        return -1;
    count = GBWImage->LoadUserExtend(file,sides,UNITTYPEMAX-UNITSTANDARD);
    if(count%20)
        count = (count/20)*20;
    count /= 2;       // Qwc̐Ȃ̂ŊB
    count += UNITSTANDARD;
    lines = count/10;
    if(BaseData1->NoStandard)
        lines -= UNITSTANDARD/10;
    //bmp->PixelFormat = pf8bit;
    //bmp->Palette = GBWImage->palette;
    bmp->Width = nw*10 + sw*5;
    bmp->Height = nh*(8+lines*2);
    for(num=0;num<GROUNDMAX;num++){
        nx = (num%10)*nw;
        // {݂ŏɎĂ悤ɕёւsB
        // ʓ|Ȃ̂łlwB
        if(num < BUILDINGMAX*2){
            ny = (4 + num/10)*nh;
        }else{
            if(num < BUILDINGMAX*3){
                ny = (2 + (num%20)/10)*nh;
            }else{
                ny = ((num%20)/10)*nh;
            }
        }
        image_g_n->Draw(bmp->Canvas,nx,ny,num);
        sx = nw*10 + (num%5)*sw;
        sy = ny + ((num%10)/5)*sh;
        image_g_s->Draw(bmp->Canvas,sx,sy,num);
    }

    int start=0,minus=0;
    if(BaseData1->NoStandard){
        start = UNITSTANDARD;
        minus = -(UNITSTANDARD/10)*nh;
    }
    currentY = nh*8;
    for(side=0;side<sides;side++){
        for(num=start;num<count;num++){
            int gnum = UNITTYPEMAX*side + num;
            nx = (num%10)*nw;
            ny = currentY + (num/10)*nh;
            image_u_n->Draw(bmp->Canvas,nx,ny+minus,gnum);
            sx = nw*10 + (num%5)*sw;
            sy = ny + ((num%10)/5)*sh;
            image_u_s->Draw(bmp->Canvas,sx,sy+minus,gnum);
        }
        currentY += lines*nh;
    }

    bmp->SaveToFile(file);
    delete bmp;
    return 0;
}
//---------------------------------------------------------------------------

