//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include <time.h>
#include <dos.h>
#include <stdlib.h>
#include <fcntl.h>
#include <io.h>
#include <sys\stat.h>
#include <Clipbrd.hpp>
#pragma hdrstop

#include "version.h"
#include "gbwedit1.h"
#include "prpty1.h"

#define VERSIONSTRING "ǒn헪}bvGfB^ for Ver.1.46"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cgauges"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    int i;

    NowRunning=true;
    PanelX=-1;
    Map1=new MapData();
    Map1->Initialize();
    MapBackup=new MapData();
    MapBackup->Initialize();
    GBWImage1=new GBWImageData();

    FieldScreen1=new FieldScreen(false);
    FieldScreen1->DefineImageList(GBWImage1,0);

    BaseData1=new BaseData();
    BaseData1->ReadStandard();

    System1=new SystemStatus();

//    OpenMapDialog=new OpenGBWMapDialog();

    for(i=0;i<2;i++){
        SideStatus1[i]=new SideStatus(i);
        Purposes1[i]=new GamePurposes();
    }
    MapSizeSet();
    ImageLoad();
    FieldScreen1->DrawMap(Map1,false);
    ScreenPut();
    StartGroundEdit();
    PenStatusPut();
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1(void)
{
    delete Map1;
    delete MapBackup;
    delete GBWImage1;
    delete FieldScreen1;
    delete BaseData1;
    delete Purposes1[0];
    delete Purposes1[1];
    delete SideStatus1[0];
    delete SideStatus1[1];
    delete System1;
//    delete OpenMapDialog;
    NowRunning=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnForm1Show(TObject *Sender)
{
    Option.Load();
    Option.GetWindowState(&Option.WindowState_gbwedit, this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnForm1Close(TObject *Sender, TCloseAction &Action)
{
    if(!MapModifiedCheck())
        Action=caNone;

    Option.SetWindowState(&Option.WindowState_gbwedit, this);
    Option.Save();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnForm1Paint(TObject *Sender)
{
    DefocusControl(ListBox1,false);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnForm1Resize(TObject *Sender)
{
    ScrollBox1->Width=ClientWidth-RIGHTSPACE;

    const int halfH=71,fullH=137;
    int needh;

    needh = Image_PenStatus->Top + fullH + 32
           +Image_GroundStatus->Height + 8 + fullH;

    if(Panel1->Height < needh){
        Image_PenStatus->Height = halfH;
        Image_UnitStatus->Height = halfH;
    }else{
        Image_PenStatus->Height = fullH;
        Image_UnitStatus->Height = fullH;
    }
    Image_GroundStatus->Top
        = Image_PenStatus->Top + Image_PenStatus->Height + 32;
    Image_UnitStatus->Top
        = Image_GroundStatus->Top + Image_GroundStatus->Height + 8;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnForm1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    switch(Key){
    case VK_LEFT:
        ScrollBox1->HorzScrollBar->Position -= FieldScreen1->GraphDegree;
        break;
    case VK_UP:
        ScrollBox1->VertScrollBar->Position -= FieldScreen1->GraphDegree;
        break;
    case VK_RIGHT:
        ScrollBox1->HorzScrollBar->Position += FieldScreen1->GraphDegree;
        break;
    case VK_DOWN:
        ScrollBox1->VertScrollBar->Position += FieldScreen1->GraphDegree;
        break;
    }
    if(Shift * (TShiftState()<<ssCtrl) != TShiftState())
        switch(Key){
        case 'O':
        case 'o':
            if(MI_Open->Enabled)
                MI_OpenClick(Sender);
            break;
        case 'S':
        case 's':
            if(MI_Save->Enabled)
                MI_SaveClick(Sender);
            break;
        case 'P':
        case 'p':
            if(MI_Property->Enabled)
                MI_PropertyClick(Sender);
            break;
        case 'U':
        case 'u':
            if(MI_Undo->Enabled)
                MI_UndoClick(Sender);
            break;
        case 'C':
        case 'c':
            if(MI_Copy->Enabled)
                MI_CopyClick(Sender);
            break;
        case 'V':
        case 'v':
            if(MI_Paste->Enabled)
                MI_PasteClick(Sender);
            break;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnList1DrawItem(TWinControl *Control, int Index,
      TRect &Rect, TOwnerDrawState State)
{
    static int OldIndex=-1;
    TImageList *ImageListp;
    TRect Rect1;
    int OldNum,Num;

    switch(System1->DrawMode){
    case MODE_DRAWGROUND:
        ImageListp=GBWImage1->ImageList_MapN;
        OldNum=OldIndex;
        Num=Index;
        break;
    case MODE_DRAWUNIT:
        ImageListp=GBWImage1->ImageList_UnitN;
        if(OldIndex!=-1 && OldIndex<ListBox1->Items->Count)
            OldNum=ListBox1->Items->Strings[OldIndex].ToIntDef(0);
        Num=ListBox1->Items->Strings[Index].ToIntDef(0);
        break;
    }
    ListBox1->Canvas->Brush->Color=clWindow;
    if(ListBox1->Selected[Index]){
        if(OldIndex!=-1){
            Rect1=Rect;
            Rect1.Top+=(OldIndex-Index)*ListBox1->ItemHeight;
            Rect1.Bottom=Rect1.Top+ListBox1->ItemHeight;
            ListBox1->Canvas->FillRect(Rect1);
            ImageListp->Draw(ListBox1->Canvas,Rect1.Left,Rect1.Top,OldNum);
        }
        System1->PenNumber=OldNum=Num;
        OldIndex=Index;
        ListBox1->Canvas->Brush->Color=clActiveCaption;
        PenStatusPut();
    }
    ListBox1->Canvas->FillRect(Rect);
    ImageListp->Draw(ListBox1->Canvas,Rect.Left,Rect.Top,Num);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnImage1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if(System1->ShowRange){ //˒͈͏
        FieldScreen1->RestoreBitmap(BKUP_NORMAL);
        ScreenRevise(FieldScreen1->BackupRect[BKUP_NORMAL]);
        System1->ShowRange=false;
        ChangeNavigateMessage(X,Y);
        return;
    }
    switch(Button){
    case (TMouseButton)mbLeft:
        System1->LeftButton=true;
        PenLeftDown(X,Y);
        break;
    case (TMouseButton)mbRight:
        System1->RightButton=true;
        PenRightDown(X,Y);
        break;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnImage1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    if(System1->LeftButton)
        PenLeftDrag(X,Y);
    else
        PenMove(X,Y);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnImage1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    switch(Button){
    case (TMouseButton)mbLeft:
        System1->LeftButton=false;
        PenLeftUp(X,Y);
        break;
    case (TMouseButton)mbRight:
        System1->RightButton=false;
        break;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_OpenClick(TObject *Sender)
{
    if(!MapModifiedCheck())
        return;
    if(OpenDialog1->Execute()){
        strcpy(System1->EditFile,OpenDialog1->FileName.c_str());
        LoadMap(System1->EditFile);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_SaveClick(TObject *Sender)
{
    int i=1;

    if(!strcmp(System1->EditFile,NEWFILENAME))
        i=SaveNameDialog();
    if(i)
        SaveMap(System1->EditFile);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_SaveAsClick(TObject *Sender)
{
    if(SaveNameDialog())
        SaveMap(System1->EditFile);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_UndoClick(TObject *Sender)
{
    *Map1=*MapBackup;
    FieldScreen1->DrawMap(Map1,false);
    EditorAllUnitPut();
    ScreenPut();
    UndoEnabled(false);
    System1->MapModified=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_PropertyClick(TObject *Sender)
{
    TForm_Property1 *Dialogp=new TForm_Property1(this);
    UnionStatusViewer *UnionSV;
    GamePurposes *BackPurposes[2];
    char str[50];
    int i;

    for(i=0;i<2;i++){
        BackPurposes[i]=new GamePurposes();
        *BackPurposes[i]=*Purposes1[i];
    }
    UnionSV=new UnionStatusViewer();
    UnionSV->MakeLabels(Dialogp->Image_Building1,Dialogp->Image_Building2);
    Dialogp->BaseDatap=BaseData1;
    for(i=0;i<2;i++)
        Dialogp->Purposesp[i]=Purposes1[i];
    Dialogp->EditMapX->Text=Map1->Width;
    Dialogp->EditMapY->Text=Map1->Height;
    Dialogp->EditMapName->Text=Map1->Name;
    Dialogp->Edit_UnitFile->Text=Map1->UnitDataFile;
    Dialogp->Edit_Money1->Text = SideStatus1[0]->Money;
    Dialogp->Edit_Money2->Text = SideStatus1[1]->Money;
    Dialogp->Label_Union1Name->Caption=BaseData1->SideName[0];
    Dialogp->Label_Union2Name->Caption=BaseData1->SideName[1];
    SideStatus1[0]->CalcIncome(Map1,BaseData1);
    sprintf(str,"@%6d",SideStatus1[0]->Income);
    Dialogp->Label_BlueIncome->Caption=str;
    SideStatus1[1]->CalcIncome(Map1,BaseData1);
    sprintf(str,"@%6d",SideStatus1[1]->Income);
    Dialogp->Label_RedIncome->Caption=str;
    sprintf(str,"jbg@%3d",SideStatus1[0]->UnitCount);
    Dialogp->Label_BlueUnit->Caption=str;
    sprintf(str,"jbg@%3d",SideStatus1[1]->UnitCount);
    Dialogp->Label_RedUnit->Caption=str;
    UnionSV->Show(BaseData1,Map1,GBWImage1);

    Dialogp->ShowModal();
    if(Dialogp->Result){
        Map1->Width  = Dialogp->EditMapX->Text.ToInt();
        Map1->Height = Dialogp->EditMapY->Text.ToInt();
        SideStatus1[0]->Money = Dialogp->Edit_Money1->Text.ToInt();
        SideStatus1[1]->Money = Dialogp->Edit_Money2->Text.ToInt();
        strcpy(Map1->Name,Dialogp->EditMapName->Text.c_str());
        strcpy(Map1->UnitDataFile,Dialogp->Edit_UnitFile->Text.c_str());
        MapSizeSet();
        CheckOutOfMap();
        FieldScreen1->DrawMap(Map1,false);
        EditorAllUnitPut();
        ScreenPut();
        if(BaseData1->ReadUser(Map1->UnitDataFile)!=-1)
            GBWImage1->LoadUserExtend(BaseData1->UserBitmapFile,BaseData1->Sides,BaseData1->UnitGrpGet);
        if(System1->DrawMode==MODE_DRAWUNIT)
            StartUnitEdit();
        System1->MapModified=true; //OKύXɂȂ
        UndoEnabled(false);
    }
    else
        for(i=0;i<2;i++)
            *Purposes1[i]=*BackPurposes[i];

    for(i=0;i<2;i++)
        delete BackPurposes[i];
    delete Dialogp;
    delete UnionSV;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_ExitClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnListBox1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    DefocusControl(ListBox1,false);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_VersionClick(TObject *Sender)
{
    ShowMessage(VERSIONSTRING);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GraphNormalClick(TObject *Sender)
{
    int i;

    FieldScreen1->DefineImageList(GBWImage1,0);
    MapSizeSet();
    FieldScreen1->DrawMap(Map1,false);
    for(i=0;i<2;i++)
        FieldScreen1->DrawAllUnit(Map1,SideStatus1[i],false);
    ScreenPut();
    MI_GraphNormal->Checked=true;
    MI_GraphSmall->Checked=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GraphSmallClick(TObject *Sender)
{
    int i;

    FieldScreen1->DefineImageList(GBWImage1,1);
    MapSizeSet();
    FieldScreen1->DrawMap(Map1,false);
    for(i=0;i<2;i++)
        FieldScreen1->DrawAllUnit(Map1,SideStatus1[i],false);
    ScreenPut();
    MI_GraphNormal->Checked=false;
    MI_GraphSmall->Checked=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MenuGraphNormalClick(TObject *Sender)
{
    SpeedButton_GraphNormal->Click();
    SpeedButton_GraphNormal->Down=true;
    SpeedButton_GraphSmall->Down=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MenuGraphSmallClick(TObject *Sender)
{
    SpeedButton_GraphSmall->Click();
    SpeedButton_GraphNormal->Down=false;
    SpeedButton_GraphSmall->Down=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrawGroundClick(TObject *Sender)
{
    if(System1->DrawMode==MODE_DRAWGROUND)
        return;
    System1->DrawMode=MODE_DRAWGROUND;
    if(System1->ShowRange){
        FieldScreen1->RestoreBitmap(BKUP_NORMAL);
        ScreenRevise(FieldScreen1->BackupRect[BKUP_NORMAL]);
        System1->ShowRange=false;
    }
    StartGroundEdit();
    SpeedButton_DrawGround->Down=true;
    SpeedButton_DrawUnit->Down=false;
    MI_DrawGround->Checked=true;
    MI_DrawUnit->Checked=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_DrawUnitClick(TObject *Sender)
{
    if(System1->DrawMode==MODE_DRAWUNIT)
        return;
    System1->DrawMode=MODE_DRAWUNIT;
    StartUnitEdit();
    SpeedButton_DrawGround->Down=false;
    SpeedButton_DrawUnit->Down=true;
    MI_DrawGround->Checked=false;
    MI_DrawUnit->Checked=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_Edit_PenClick(TObject *Sender)
{
    DrawGroundClick(Sender);
    MI_Edit_Pen->Checked=true;
    SpeedButton_Pen->Down=true;
    MI_Edit_BoxFill->Checked=false;
    SpeedButton_BoxFill->Down=false;
    MI_Edit_BoxSelect->Checked=false;
    SpeedButton_BoxSelect->Down=false;
    System1->DrawGroundMode = DGMODE_PEN;
    StartPenMode();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_Edit_BoxFillClick(TObject *Sender)
{
    DrawGroundClick(Sender);
    MI_Edit_Pen->Checked=false;
    SpeedButton_Pen->Down=false;
    MI_Edit_BoxFill->Checked=true;
    SpeedButton_BoxFill->Down=true;
    MI_Edit_BoxSelect->Checked=false;
    SpeedButton_BoxSelect->Down=false;
    System1->DrawGroundMode = DGMODE_BOXFILL;
    StartBoxFillMode();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_Edit_BoxSelectClick(TObject *Sender)
{
    DrawGroundClick(Sender);
    MI_Edit_Pen->Checked=false;
    SpeedButton_Pen->Down=false;
    MI_Edit_BoxFill->Checked=false;
    SpeedButton_BoxFill->Down=false;
    MI_Edit_BoxSelect->Checked=true;
    SpeedButton_BoxSelect->Down=true;
    System1->DrawGroundMode = DGMODE_BOXSELECT;
    StartBoxSelectMode();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_CopyClick(TObject *Sender)
{
    if(System1->DrawGroundMode == DGMODE_BOXSELECT)
        if(SelectedRect.AreaSelected() && System1->SelectDecided)
            Container.CopyToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_PasteClick(TObject *Sender)
{
    if(Container.PasteFromClipboard()==-1){
        ShowMessage("Nbv{[hɓe܂B");
        return;
    }
    if(System1->DrawMode==MODE_DRAWGROUND && System1->DrawGroundMode==DGMODE_BOXSELECT)
        PenRightDown(0,0); //I𑀍Ă\Ή
    else{
        MI_Edit_BoxSelectClick(Sender);
//        System1->DrawMode = MODE_DRAWGROUND;
//        System1->DrawGroundMode = DGMODE_BOXSELECT;
    }
    SelectedRect = Container.ContainRect;
    SelectedRect.Move(-Container.ContainRect.Left, -Container.ContainRect.Top);
    SelectedRect.Normalize();
    Container.PasteFromBuffer(Map1,SelectedRect.Left,SelectedRect.Top,false,false,NULL);
    DrawBoxSelect(SelectedRect,false,true); //obNAbvזʕ`
    CopySelectedMapChip(false);
    Container.PasteFromBuffer(Map1,SelectedRect.Left,SelectedRect.Top,false,false,NULL);
    DrawBoxSelect(SelectedRect,false,false);
    System1->SelectDecided = true;
}
//---------------------------------------------------------------------------

__fastcall TForm1::ScreenPut(void)
{
    int x2,y2;

    if(!NowRunning)
        return 0;
    x2=Image1->Width;
    y2=Image1->Height;
    if(FieldScreen1->RectX1+x2>FieldScreen1->Bitmap->Width){
        Image1->Canvas->Brush->Color=clBlack;
        Image1->Canvas->FillRect(Rect(FieldScreen1->Bitmap->Width-FieldScreen1->RectX1,0,x2,y2));
    }
    if(FieldScreen1->RectY1+y2>FieldScreen1->Bitmap->Height){
        Image1->Canvas->Brush->Color=clBlack;
        Image1->Canvas->FillRect(Rect(0,FieldScreen1->Bitmap->Height-FieldScreen1->RectY1,x2,y2));
    }
    Image1->Canvas->CopyRect(Rect(0,0,x2,y2),FieldScreen1->Bitmap->Canvas,Rect(FieldScreen1->RectX1,FieldScreen1->RectY1,FieldScreen1->RectX1+x2,FieldScreen1->RectY1+y2));
    if(SelectedRect.AreaSelected())
        DrawBoxSelect(SelectedRect,false,true);
    return 0;
}
//---------------------------------------------------------------------------

__fastcall TForm1::ImageLoad(void)
{
    GBWImage1->Load(GetDeviceCaps(Canvas->Handle,BITSPIXEL));
    return 0;
}
//---------------------------------------------------------------------------

__fastcall TForm1::ScreenRevise(int x1,int y1,int x2,int y2)
{
    int u1,v1,u2,v2;

    u1=FieldScreen1->RectX1+x1;
    v1=FieldScreen1->RectY1+y1;
    u2=u1+x2-x1;
    v2=v1+y2-y1;
    Image1->Canvas->CopyRect(Rect(u1,v1,u2,v2),FieldScreen1->Bitmap->Canvas,Rect(x1,y1,x2,y2));
    return 0;
}
//---------------------------------------------------------------------------
//}bv摜̈ꕔXViRectŁj
__fastcall TForm1::ScreenRevise(TRect Rect1)
{
    Image1->Canvas->CopyRect(Rect1,FieldScreen1->Bitmap->Canvas,Rect1);
    return 0;
}
//---------------------------------------------------------------------------
//}bv摜PubNXVi_WŎwj
__fastcall TForm1::ScreenReviseBlock(int zx,int zy)
{
    int x,y;

    FieldScreen1->XY_MapToPhy(zx,zy,&x,&y);
    ScreenRevise(x,y,x+FieldScreen1->GraphDegree,y+FieldScreen1->GraphDegree);
    return 0;
}
//---------------------------------------------------------------------------
//eLXg`Ń}bvZ[uB
__fastcall TForm1::SaveMap(char *file)
{
    TDataTable *table = new TDataTable();
    char key[100];
    bool Error=false;
    int i,j,x,y;

    for(y=0;y<Map1->Height;y++)
        for(x=0;x<Map1->Width;x++){
            if(Map1->Data[x][y].Graph%BUILDINGMAX > 12)
                Error=true; //gȂn``FbN
        }
    if(Error){
        ShowMessage("gpłȂn`܂܂Ă܂B\n~󂪕`ꂽn`͎g܂B");
        return -1;
    }

    table->SetCategory("Map property");
    table->Put(KEY_MAPVERSION,MAPVERNUMBER);
    Map1->WriteTextCompact(table); //MapDataNX̓ei[

    //i[
    for(i=0;i<2;i++){
        sprintf(key,"%s%d",KEY_BEGINMONEY,i);
        table->Put(key,SideStatus1[i]->Money);
    }

    //zujbgi[
    for(i=0;i<2;i++){
        sprintf(key,"%s%d",CTG_UNITS,i);
        table->SetCategory(key);
        for(j=0; j<SideStatus1[i]->UnitCount; j++){
            sprintf(key,"%s%d",KEY_UNITTYPE,j);
            table->Put(key,SideStatus1[i]->Unit[j].Type);
            sprintf(key,"%s%d",KEY_UNITXY,j);
            table->PutTwoValues(key,SideStatus1[i]->Unit[j].X,
                                    SideStatus1[i]->Unit[j].Y);
        }
    }


/*
    bool SetUnit,SetPurpose=true,UnitExtend=true,BeginMoney=true;

    handle=open(file,O_BINARY|O_RDWR|O_TRUNC|O_CREAT,S_IWRITE);
    if(handle==-1)
        return -1;
    write(handle,MAPVERHEAD,(sizeof MAPVERHEAD)-1);
    write(handle,MAPVERSION,sizeof MAPVERSION);
    write(handle,Map1->Name,sizeof Map1->Name);
    write(handle,&Map1->Width,sizeof Map1->Width);
    write(handle,&Map1->Height,sizeof Map1->Height);
    for(y=0;y<Map1->Height;y++)
        for(x=0;x<Map1->Width;x++)
            write(handle,&Map1->Data[x][y].Graph,1);

    SetUnit = SideStatus1[0]->UnitCount || SideStatus1[1]->UnitCount;
    write(handle,&SetUnit,sizeof SetUnit);
    if(SetUnit)  //jbgzu
        for(i=0;i<2;i++){
            s=(short)SideStatus1[i]->UnitCount;
            write(handle,&s,sizeof s);
            for(j=0;j<SideStatus1[i]->UnitCount;j++){
                s=(short)SideStatus1[i]->Unit[j].Type;
                write(handle,&s,sizeof s);
                s=(short)SideStatus1[i]->Unit[j].X;
                write(handle,&s,sizeof s);
                s=(short)SideStatus1[i]->Unit[j].Y;
                write(handle,&s,sizeof s);
            }
        }
*/
/*
    write(handle,&SetPurpose,sizeof SetPurpose); //true܂ȂB
    for(i=0;i<2;i++)
        Purposes1[i]->Write(handle);

    write(handle,&UnitExtend,sizeof UnitExtend); //true܂ȂB
    write(handle,Map1->UnitDataFile,sizeof Map1->UnitDataFile);

    write(handle,&BeginMoney,sizeof BeginMoney); //true܂ȂB
    write(handle,&SideStatus1[0]->Money,sizeof(int));
    write(handle,&SideStatus1[1]->Money,sizeof(int));

    close(handle);
*/
    table->SaveToFile(file);
    delete table;
    System1->MapModified=false;
    return 0;
}
//---------------------------------------------------------------------------
//}bvt@C̃[hB̏Oo[WƂ̌݊cĂB
__fastcall TForm1::LoadMap(char *file)
{
    TDataTable *table;
    char key[100],c;
    int handle,uType,uGraph,ux,uy,i,j;

    //o[W̃t@Cǂ𔻕
    handle=open(file,O_BINARY|O_RDONLY);
    if(handle==-1)
        return -1;
    read(handle,&c,1);
    close(handle);
    if(c != '[')
        return LoadMapBinary(file);

    table = new TDataTable();
    table->LoadFromFile(file);

    for(i=0;i<=1;i++)
        SideStatus1[i]->Initialize();
    Map1->Initialize();
    Map1->ReadTextCompact(table); //MapDataNX̓eo

    //ǂ
    for(i=0;i<2;i++){
        sprintf(key,"%s%d",KEY_BEGINMONEY,i);
        table->Get(key,&SideStatus1[i]->Money);
    }

    //zujbgǂ
    for(i=0;i<2;i++){
        sprintf(key,"%s%d",CTG_UNITS,i);
        table->GetCategory(key);
        for(j=0; j<UNITMAX; j++){
            sprintf(key,"%s%d",KEY_UNITTYPE,j);
            if(table->Get(key,&uType) != -1){
                sprintf(key,"%s%d",KEY_UNITXY,j);
                table->GetTwoValues(key,&ux,&uy);
                uGraph = i*UNITTYPEMAX+uType;
                SideStatus1[i]->AddUnit(BaseData1,ux,uy,uGraph);
                SideStatus1[i]->Unit[j].Actioned=false;
                if(Map1->Data[ux][uy].Side == -1){
                    Map1->Data[ux][uy].Side=(char)i;
                    Map1->Data[ux][uy].Unit=(char)j;
                }
                else{
                    SideStatus1[i]->LoadUnit(Map1->Data[ux][uy].Unit,j);
                }
            }
            else
                break;
        }
    }

    if(BaseData1->ReadUser(Map1->UnitDataFile)!=-1)
        GBWImage1->LoadUserExtend(BaseData1->UserBitmapFile,BaseData1->Sides,BaseData1->UnitGrpGet);
    if(System1->DrawMode==MODE_DRAWUNIT)
        StartUnitEdit();

    MapSizeSet();
    FieldScreen1->DrawMap(Map1,false);
    EditorAllUnitPut();
    ScreenPut();
    System1->MapModified=false;
    UndoEnabled(false);
    return 0;
}
//---------------------------------------------------------------------------
//oCit@CǂށBȑÕo[Wi1.37܂ŁjMapLoad()֐B
__fastcall TForm1::LoadMapBinary(char *file)
{
    VersionControl Version1;
    char str[(sizeof MAPVERHEAD)];
    bool SetUnit,SetPurpose,UnitExtend,BeginMoney;
    short s;
    int handle,h,i,j,k,Graph,x,y,zx,zy,v1,v2;

    handle=open(file,O_BINARY|O_RDONLY);
    if(handle==-1)
        return -1;
    read(handle,str,(sizeof MAPVERHEAD)-1);
    str[(sizeof MAPVERHEAD)-1]='\0';
    if(strcmp(str,MAPVERHEAD)){
        ShowMessage("ǒn헪̃}bv`ł͂܂B\n");
        close(handle);
        return -1;
    }
    read(handle,str,VERSIONLENGTH+1);
    v1=Version1.StrToValue(str);
    v2=Version1.StrToValue(MAPVERSION);
    if(v1>v2){
        ShowMessage("}bv`̃o[WႢ܂B\n");
        close(handle);
        return -1;
    }

    for(i=0;i<=1;i++)
        SideStatus1[i]->Initialize();
    Map1->Initialize();
    read(handle,Map1->Name,sizeof Map1->Name);
    read(handle,&Map1->Width,sizeof Map1->Width);
    read(handle,&Map1->Height,sizeof Map1->Height);
    if(v1<102){
        for(y=0;y<MAPHEIGHT_OLD;y++)
            for(x=0;x<MAPWIDTH_OLD;x++)
                read(handle,&Map1->Data[x][y].Graph,1);
    }
    else
        for(y=0;y<Map1->Height;y++)
            for(x=0;x<Map1->Width;x++)
                read(handle,&Map1->Data[x][y].Graph,1);

    i=read(handle,&SetUnit,sizeof SetUnit);
    if(i && (int)SetUnit==1)  //jbgzu
        for(i=0;i<2;i++){
            read(handle,&s,sizeof s);
            k=s;  //UnitCount
            if(v1<102) //1.01ȑOUnitCountɊւ炸萔Ă
                h=UNITMAX_OLD;
            else
                h=k;
            for(j=0;j<h;j++){
                read(handle,&s,sizeof s);
                Graph=i*UNITTYPEMAX+s;
                read(handle,&s,sizeof s);
                zx=s;
                read(handle,&s,sizeof s);
                zy=s;
                if(j<k){
                    SideStatus1[i]->AddUnit(BaseData1,zx,zy,Graph);
                    SideStatus1[i]->Unit[j].Actioned=false;
                    if(Map1->Data[zx][zy].Side == -1){
                        Map1->Data[zx][zy].Side=(char)i;
                        Map1->Data[zx][zy].Unit=(char)j;
                    }
                    else{
                        SideStatus1[i]->LoadUnit(Map1->Data[zx][zy].Unit,j);
                    }
                }
            }
        }

    i=read(handle,&SetPurpose,sizeof SetPurpose);
    if(i && SetPurpose) //BڕW
        for(i=0;i<2;i++)
            Purposes1[i]->Read(handle);
    else
        for(i=0;i<2;i++)
            Purposes1[i]->Initialize();

    i=read(handle,&UnitExtend,sizeof UnitExtend);
    if(i && UnitExtend) //jbgf[^
        read(handle,Map1->UnitDataFile,sizeof Map1->UnitDataFile);
    i=read(handle,&BeginMoney,sizeof BeginMoney);
    if(i && BeginMoney){ //
        read(handle,&SideStatus1[0]->Money,sizeof(int));
        read(handle,&SideStatus1[1]->Money,sizeof(int));
    }
    close(handle);

    if(BaseData1->ReadUser(Map1->UnitDataFile)!=-1)
        GBWImage1->LoadUserExtend(BaseData1->UserBitmapFile,BaseData1->Sides,BaseData1->UnitGrpGet);
    if(System1->DrawMode==MODE_DRAWUNIT)
        StartUnitEdit();
    if(v1<v2)  //o[Wt@C̃Ro[g
        Map1->VersionConvert(v1);

    MapSizeSet();
    FieldScreen1->DrawMap(Map1,false);
    EditorAllUnitPut();
    ScreenPut();
    System1->MapModified=false;
    UndoEnabled(false);
    return 0;
}
//---------------------------------------------------------------------------

__fastcall TForm1::SaveNameDialog(void)
{
    int r;

    SaveDialog1->FileName=System1->EditFile;
    r=SaveDialog1->Execute();
    if(r)
        if(!access(SaveDialog1->FileName.c_str(),0))
            if(MessageDlg("̃t@C͊ɑ݂܂B㏑܂H", mtConfirmation,TMsgDlgButtons() << mbYes << mbNo, 0)==mrNo)
                r=false;
    if(r)
        strcpy(System1->EditFile,SaveDialog1->FileName.c_str());

    return r;
}
//---------------------------------------------------------------------------

__fastcall TForm1::ModifiedSaveDialog(void)
{
    int r;

    r=MessageDlg("ύXĂ܂Bۑ܂H", mtConfirmation,TMsgDlgButtons() << mbYes << mbNo << mbCancel, 0);
    return r;
}
//---------------------------------------------------------------------------
//݂̃}bvύXĂZ[u₢킹B
//[U[LZI񂾂߂lfalseB
__fastcall TForm1::MapModifiedCheck(void)
{
    int i;
    bool r=true;

    if(System1->MapModified){
        i=ModifiedSaveDialog();
        switch(i){
        case mrYes:
            i=SaveNameDialog();
            if(i)
                SaveMap(System1->EditFile);
            else
                r=false;
            break;
        case mrNo:
            break;
        case mrCancel:
            r=false;
            break;
        }
    }
    return (int)r;
}
//---------------------------------------------------------------------------
//}bṽTCYƃrbg}bṽTCY킹
__fastcall TForm1::MapSizeSet(void)
{
    FieldScreen1->Initialize(Map1->Width,Map1->Height);
    Image1->Picture->Bitmap->Width=FieldScreen1->Bitmap->Width;
    Image1->Picture->Bitmap->Height=FieldScreen1->Bitmap->Height;
    return 0;
}
//---------------------------------------------------------------------------
//}bv̊Oɂ郆jbg폜iTCYύXj
__fastcall TForm1::CheckOutOfMap(void)
{
    int x,y,Side,Num;

    for(y=0;y<MAPHEIGHTMAX;y++)
        for(x=0;x<MAPWIDTHMAX;x++)
            if(x>=Map1->Width || y>=Map1->Height)
                if(Map1->Data[x][y].Side!=-1){
                    Side=Map1->Data[x][y].Side;
                    Num=Map1->Data[x][y].Unit;
                    Map1->Data[x][y].Side=-1;
                    SideStatus1[Side]->DeleteUnit(Map1,Num);
                }
    return 0;
}
//---------------------------------------------------------------------------
//GfB^p
__fastcall TForm1::EditorAllUnitPut(void)
{
    int i;

    for(i=0;i<2;i++){
        SideStatus1[i]->EndClear();
        FieldScreen1->DrawAllUnit(Map1,SideStatus1[i],false);
    }
    return 0;
}
//---------------------------------------------------------------------------
//݂̃y̒n`^jbg\
__fastcall TForm1::PenStatusPut(void)
{
    switch(System1->DrawMode){
    case MODE_DRAWGROUND:
        PenStatusPut_Ground(System1->PenNumber);
        break;
    case MODE_DRAWUNIT:
        PenStatusPut_Unit(System1->PenNumber);
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//݂̃y̒n`\
__fastcall TForm1::PenStatusPut_Ground(int index)
{
    MapStatus gnd;
    MapChip *gndInfop = &BaseData1->MapInfo[index];
    gnd.Initialize(index);
    FieldScreen1->DrawGroundStatusToTCanvas(Image_PenStatus->Canvas,Panel1->Brush->Color,0,0,&gnd,gndInfop);
    return 0;
}
//---------------------------------------------------------------------------
//݂̃ỹjbg\
__fastcall TForm1::PenStatusPut_Unit(int index)
{
    int type = index%UNITTYPEMAX;
    UnitStatus unit;
    UnitChip *unitInfop = &BaseData1->UnitInfo[type];

    unit.SetDefault(index,type,unitInfop);
    FieldScreen1->DrawUnitStatusToTCanvas(Image_PenStatus->Canvas,Panel1->Brush->Color,0,0,&unit,unitInfop);
    return 0;
}
//---------------------------------------------------------------------------
//{^̏
__fastcall TForm1::PenLeftDown(int x,int y)
{
    int zx,zy;

    FieldScreen1->XY_PhyToMap(Map1,x,y,&zx,&zy);
    switch(System1->DrawMode){
    case MODE_DRAWGROUND:
        switch(System1->DrawGroundMode){
        case DGMODE_PEN:
            *MapBackup=*Map1;
            MapChipWrite(zx,zy,System1->PenNumber);
            UndoEnabled(true);
            break;
        case DGMODE_BOXFILL:
        case DGMODE_BOXSELECT:
            if(!SelectedRect.AreaSelected()){
                SelectedRect.SelectAreaFirst(zx,zy,zx,zy);
                Container.CopyToBuffer(Map1,SelectedRect);
                Container.PasteFromBuffer(Map1);
                DrawBoxSelect(SelectedRect,false,true);
            }
            else{
                if(!System1->SelectDecided){
                    SelectedRect.SelectAreaSecond(zx,zy);
                    System1->SelectDecided=true;
                    if(System1->DrawGroundMode == DGMODE_BOXFILL){
                        *MapBackup=*Map1;
                        WriteSelectedMapChip(System1->PenNumber);
                        EndBoxSelect(true);
                        UndoEnabled(true);
                    }
                    else{
                        SelectedRect.Normalize();
                        Container.CopyToBuffer(Map1,SelectedRect);
                        Container.PasteFromBuffer(Map1);
                        MI_Copy->Enabled=true;
//                        FieldScreen1->Backuped=false;
                    }
                }
                else
                    if(System1->DrawGroundMode == DGMODE_BOXSELECT)
                        if(Map1->RangePoint[zx][zy]){
                            System1->NowDragging=true;
                            DragRect.SelectAreaFirst(zx,zy,zx,zy);
                        }
            }
            break;
        }
        break;
    case MODE_DRAWUNIT:
        UnitWrite(zx,zy,System1->PenNumber);
        UndoEnabled(false);
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//{^ŃhbȌ
__fastcall TForm1::PenLeftDrag(int x,int y)
{
    int zx,zy,dx,dy;
//    OperateRect WriteRect;

    FieldScreen1->XY_PhyToMap(Map1,x,y,&zx,&zy);
    switch(System1->DrawMode){
    case MODE_DRAWGROUND:
        if(System1->DrawGroundMode == DGMODE_PEN){
            MapChipWrite(zx,zy,System1->PenNumber);
            break;
        }
        if(System1->DrawGroundMode == DGMODE_BOXSELECT){
            if(DragRect.AreaSelected() && System1->NowDragging){
                DragRect.SelectAreaSecond(zx,zy);
                DragRect.Difference(&dx,&dy);
                SelectedRect.Move(dx,dy);
                DragRect.Move(dx,dy);
                Container.PasteFromBuffer(Map1,SelectedRect.Left,SelectedRect.Top,false,false,NULL);
                DrawBoxSelect(SelectedRect,true,true);
            }
            break;
        }
        PenMove(x,y);
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//{^̏
__fastcall TForm1::PenLeftUp(int x,int y)
{
    int zx,zy;

    FieldScreen1->XY_PhyToMap(Map1,x,y,&zx,&zy);
    switch(System1->DrawMode){
    case MODE_DRAWGROUND:
        if(System1->NowDragging){
            CopySelectedMapChip(false);
            Container.PasteFromBuffer(Map1,SelectedRect.Left,SelectedRect.Top,false,false,NULL);
            DrawBoxSelect(SelectedRect,false,false);
            System1->NowDragging = false;
        }
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//E{^̏
__fastcall TForm1::PenRightDown(int x,int y)
{
    int zx,zy;

    FieldScreen1->XY_PhyToMap(Map1,x,y,&zx,&zy);
    switch(System1->DrawMode){
    case MODE_DRAWGROUND:
        if(SelectedRect.AreaSelected()){
            if(DragRect.AreaSelected()){
                *MapBackup=*Map1;
                CopySelectedMapChip(true);
                DragRect.NoSelect();
                EndBoxSelect(false);
                UndoEnabled(true);
            }
            else
                EndBoxSelect(true);
        }else{
            System1->PenNumber = FieldScreen1->MapChipGet(Map1,zx,zy);
            PenStatusPut();
        }
        break;
    case MODE_DRAWUNIT:
        UnitDelete(zx,zy);
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//{^}EXJ[\̏
__fastcall TForm1::PenMove(int x,int y)
{
    int zx,zy;

    FieldScreen1->XY_PhyToMap(Map1,x,y,&zx,&zy);
    MapChipStatusPut(x,y);
    if(SelectedRect.AreaSelected() && !System1->SelectDecided){
        SelectedRect.SelectAreaSecond(zx,zy);
        Container.CopyToBuffer(Map1,SelectedRect);
        Container.PasteFromBuffer(Map1);
        DrawBoxSelect(SelectedRect,true,true);
//        StatusBar1->Panels->Items[NAVIGATEPANEL]->Text = SelectedRect.Right;
    }
    return 0;
}
//---------------------------------------------------------------------------
//w肳ꂽ`̈g`
__fastcall TForm1::DrawBoxSelect(OperateRect SelRect,bool Erase,bool Backup)
{
    TRect r;

    FieldScreen1->FastDrawMode(Image1->Canvas);
        //Image1ɒڕ`悤ɐ؂ւ
    SelRect.GetSelectedArea(&r);
    if(Erase)
        FieldScreen1->EraseBoxRange(Map1); //O̕`
    FieldScreen1->DrawBoxRange(Map1,r,Backup);
    FieldScreen1->FastDrawMode(NULL); //ɖ߂
    Image1->Refresh();
    return 0;
}
//---------------------------------------------------------------------------
//}bv̂P}XύXit[nhpj
__fastcall TForm1::MapChipWrite(int zx,int zy,int Index)
{
    int Side;

    FieldScreen1->MapChipSet(Map1,zx,zy,Index);
    Side=Map1->Data[zx][zy].Side;
    if(Side!=-1)
        FieldScreen1->UnitPutAuto(Map1,SideStatus1[Side],zx,zy,false);
    ScreenReviseBlock(zx,zy);
    System1->MapModified=true;
    return 0;
}
//---------------------------------------------------------------------------
//Iꂽ̈ύX
__fastcall TForm1::WriteSelectedMapChip(int Index)
{
    int x,y,Side;
    TRect WriteRect,ReviseRect;

    SelectedRect.GetSelectedArea(&WriteRect);
    Container.PasteFromBuffer(Map1);
    for(y=0;y<MAPHEIGHTMAX;y++)
        for(x=0;x<MAPWIDTHMAX;x++)
            if(Map1->RangePoint[x][y]){
                FieldScreen1->MapChipSet(Map1,x,y,Index);
                Side = Map1->Data[x][y].Side;
                if(Side!=-1)
                    FieldScreen1->UnitPutAuto(Map1,SideStatus1[Side],x,y,false);
            }
    FieldScreen1->GetDrawRect(Map1,&ReviseRect);
    ScreenRevise(ReviseRect);
    FieldScreen1->SelectDraw=false;
    System1->MapModified=true;
    return 0;
}
//---------------------------------------------------------------------------
//n`ҏWF`̈I
//Erase=trueȂʏ̘g
__fastcall TForm1::EndBoxSelect(bool Erase)
{
    if(SelectedRect.AreaSelected()){
        if(Erase){
            FieldScreen1->FastDrawMode(Image1->Canvas);
            FieldScreen1->EraseBoxRange(Map1);
            FieldScreen1->FastDrawMode(NULL);
            Image1->Refresh();
        }
        FieldScreen1->SelectDraw = false;
        SelectedRect.NoSelect();
        System1->SelectDecided = false;
        MI_Copy->Enabled=false;
    }
    return 0;
}
//---------------------------------------------------------------------------
//Ï̃Rs[ƕ`B
//DecidedfalseȂ獂ŕ`݂̂sB
__fastcall TForm1::CopySelectedMapChip(bool Decided)
{
    int x,y,Side;

    if(!Decided)
        FieldScreen1->FastDrawMode(Image1->Canvas);

    Container.PasteFromBuffer(Map1,SelectedRect.Left,SelectedRect.Top,true,Decided,FieldScreen1);

    for(y=0;y<MAPHEIGHTMAX;y++)
        for(x=0;x<MAPWIDTHMAX;x++)
            if(Map1->RangePoint[x][y]){
                Side = Map1->Data[x][y].Side;
                if(Side!=-1)
                    FieldScreen1->UnitPutAuto(Map1,SideStatus1[Side],x,y,false);
            }

    if(!Decided){
        FieldScreen1->FastDrawMode(NULL);
        Image1->Refresh();
    }
    else{
        ScreenRevise(FieldScreen1->BackupRect[BKUP_NORMAL]);
        System1->MapModified=true;
    }
    return 0;
}
//---------------------------------------------------------------------------
//}bv̂P}XɃjbgu
__fastcall TForm1::UnitWrite(int zx,int zy,int Index)
{
    UnitStatus *Unitp;
    int Side,Type,Num;

    if(Map1->Data[zx][zy].Side != -1){ //˒͈͕\
        Side=Map1->Data[zx][zy].Side;
        Num=Map1->Data[zx][zy].Unit;
        Unitp=&SideStatus1[Side]->Unit[Num];
        FieldScreen1->FindAttackRange(Map1,BaseData1,Unitp);
        FieldScreen1->RangePut(Map1,CURSOR_RANGE,NULL,-1,false,false);
        FieldScreen1->CursorPutZ(zx,zy,CURSOR_LOOKUP);
        ScreenRevise(FieldScreen1->BackupRect[BKUP_NORMAL]);
        System1->ShowRange=true;
        ChangeNavigateMessage(0,0);
        return 0;
    }
    Side=Index/UNITTYPEMAX;
    Type=Index%UNITTYPEMAX;
    if(SideStatus1[Side]->UnitCount>=UNITMAX){
        ShowMessage("UOłB");
        return 0;
    }
    if(!strcmp(BaseData1->UnitInfo[Type].Name,"\")){
        ShowMessage("̃jbg͖o^łB");
        return 0;
    }
    Map1->Data[zx][zy].Side=(char)Side;
    Map1->Data[zx][zy].Unit=(char)SideStatus1[Side]->UnitCount;
    SideStatus1[Side]->AddUnit(BaseData1,zx,zy,Index);
    SideStatus1[Side]->Unit[Map1->Data[zx][zy].Unit].Actioned=false;
    FieldScreen1->UnitPutZ(zx,zy,Index);
    ScreenReviseBlock(zx,zy);
    System1->MapModified=true;
    return 0;
}
//---------------------------------------------------------------------------
//ujbg폜
__fastcall TForm1::UnitDelete(int zx,int zy)
{
    int Side,Num;

    if(Map1->Data[zx][zy].Side==-1)
        return 0;
    Side=Map1->Data[zx][zy].Side;
    Num=Map1->Data[zx][zy].Unit;
    Map1->Data[zx][zy].Side=-1;
    SideStatus1[Side]->DeleteUnit(Map1,Num);
    FieldScreen1->MapChipPutZ(Map1,zx,zy);
    ScreenReviseBlock(zx,zy);
    return 0;
}
//---------------------------------------------------------------------------
//J[\n_̒n`\
__fastcall TForm1::MapChipStatusPut(int x,int y)
{
    UnitStatus *unitp;
    UnitChip *unitInfop;
    char str[10];
    int zx,zy,Side,Num;

    FieldScreen1->XY_PhyToMap(Map1,x,y,&zx,&zy);
    MapStatus *gndp = &Map1->Data[zx][zy];
    MapChip *gndInfop = &BaseData1->MapInfo[gndp->Graph];
    // MapStatus::LifeMax ĂȂ̂łŏB
    // ]̃}bvGfB^ł͒n`LifelĂȂ̂
    // ̂܂܂ƒn`\p̋ʃ[`ُ퓮삷B
    gndp->Initialize(gndp->Graph);
    FieldScreen1->DrawGroundStatusToTCanvas(Image_GroundStatus->Canvas,Panel1->Brush->Color,0,0,gndp,gndInfop);

    Side=(int)Map1->Data[zx][zy].Side; //jbg\
    Num=(int)Map1->Data[zx][zy].Unit;
    if(Side==-1){
        FillCanvas(Image_UnitStatus->Canvas, Panel1->Brush->Color);
    }
    else{
        unitp = &SideStatus1[Side]->Unit[Num];
        unitInfop = &BaseData1->UnitInfo[unitp->Type];
        FieldScreen1->DrawUnitStatusToTCanvas(Image_UnitStatus->Canvas,Panel1->Brush->Color,0,0,unitp,unitInfop);
    }

    if(zx!=PanelX || zy!=PanelY){
        sprintf(str,"x:%2d",zx);
        StatusBar1->Panels->Items[MAPXPANEL]->Text=str;
        PanelX=zx;
        sprintf(str,"y:%2d",zy);
        StatusBar1->Panels->Items[MAPYPANEL]->Text=str;
        PanelY=zy;
        ChangeNavigateMessage(x,y);
    }
    return 0;
}
//---------------------------------------------------------------------------
//n`ҏW̊Jn
__fastcall TForm1::StartGroundEdit(void)
{
    char str[10];
    int i;

    ListBox1->Clear();
    for(i=0;i<GROUNDMAX;i++){
        itoa(i,str,10);
        ListBox1->Items->Add(AnsiString(str));
    }
    System1->PenNumber=0;
    PenStatusPut();
    FillCanvas(Image_UnitStatus->Canvas, Panel1->Brush->Color);
    ChangeNavigateMessage(0,0);

    return 0;
}
//---------------------------------------------------------------------------
//jbgzůJn
__fastcall TForm1::StartUnitEdit(void)
{
    int i,n=-1;

    ListBox1->Clear();
    for(i=0;i<UNITTYPEMAX*2;i++)
        if((!BaseData1->NoStandard || i%UNITTYPEMAX>=UNITSTANDARD) && BaseData1->UnitInfo[i%UNITTYPEMAX].Defined){
            ListBox1->Items->Add(AnsiString(i));
            if(n==-1)
                n=i;
        }
    System1->PenNumber=n;
    PenStatusPut();
    ChangeNavigateMessage(0,0);
    //}bv̍ɃjbgƃbZ[WႤɂȂ肠

    return 0;
}
//---------------------------------------------------------------------------
//n`ҏWFy[h̊Jn
__fastcall TForm1::StartPenMode(void)
{
    EndBoxSelect(true);
    return 0;
}
//---------------------------------------------------------------------------
//n`ҏWF`hԂ[h̊Jn
__fastcall TForm1::StartBoxFillMode(void)
{
    EndBoxSelect(true);
    return 0;
}
//---------------------------------------------------------------------------
//n`ҏWF`I[h̊Jn
__fastcall TForm1::StartBoxSelectMode(void)
{
    EndBoxSelect(true);
    return 0;
}
//---------------------------------------------------------------------------
//irQ[gbZ[W̕\ύXB
//̓J[\̍WBMODE_DRAWUNITȊO͎gĂȂ
__fastcall TForm1::ChangeNavigateMessage(int x,int y)
{
    TStatusPanel *SP=StatusBar1->Panels->Items[NAVIGATEPANEL];
    int zx,zy;

    FieldScreen1->XY_PhyToMap(Map1,x,y,&zx,&zy);
    switch(System1->DrawMode){
    case MODE_DRAWGROUND:
        SP->Text=NAVIGATEGROUND;
        break;
    case MODE_DRAWUNIT:
        if(System1->ShowRange){
            SP->Text=NAVIGATERANGENOW;
            break;
        }
        if(Map1->Data[zx][zy].Side!=-1)
            SP->Text=NAVIGATERANGE;
        else
            SP->Text=NAVIGATEUNIT;
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//I[v̏
__fastcall TForm1::OpenEnabled(bool Value)
{
    MI_Open->Enabled=Value;
    SpeedButton_Open->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//Z[ȕ
__fastcall TForm1::SaveEnabled(bool Value)
{
    MI_Save->Enabled=Value;
    SpeedButton_Save->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//OtăZ[ȕ
__fastcall TForm1::SaveAsEnabled(bool Value)
{
    MI_SaveAs->Enabled=Value;
    SpeedButton_SaveAs->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//vpeB̏
__fastcall TForm1::PropertyEnabled(bool Value)
{
    MI_Property->Enabled=Value;
    SpeedButton_Property->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//AhD̏
__fastcall TForm1::UndoEnabled(bool Value)
{
    MI_Undo->Enabled=Value;
    SpeedButton_Undo->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//I
__fastcall OperateRect::NoSelect(void)
{
    Left   = -1;
    Right  = -1;
    return 0;
}
//---------------------------------------------------------------------------
//̈I
__fastcall OperateRect::SelectAreaFirst(int x1,int y1,int x2,int y2)
{
    Left   = x1;
    Top    = y1;
    Right  = x2;
    Bottom = y2;
    return 0;
}
//---------------------------------------------------------------------------
//̈IiQԖڂ̓_̍W߂j
__fastcall OperateRect::SelectAreaSecond(int x2,int y2)
{
    Right  = x2;
    Bottom = y2;
    return 0;
}
//---------------------------------------------------------------------------
//IĂ邩
__fastcall OperateRect::AreaSelected(void)
{
    return (Left!=-1 && Right!=-1);
}
//---------------------------------------------------------------------------
//Ï̒`Ԃ
__fastcall OperateRect::GetSelectedArea(TRect *r)
{
    OperateRect or;

    or=*this;
    or.Normalize();
    *r=or;
    return 0;
}
//---------------------------------------------------------------------------
//ォEւ̌`ɒ
__fastcall OperateRect::Normalize(void)
{
    int i;

    if(Left > Right){
        i=Right;
        Right=Left;
        Left=i;
    }
    if(Top > Bottom){
        i=Bottom;
        Bottom = Top;
        Top=i;
    }
    return 0;
}
//---------------------------------------------------------------------------
//̈`ςɂ炷iwNXpj
__fastcall OperateRect::Move(int x,int y)
{
    this->Left   += x;
    this->Top    += y;
    this->Right  += x;
    this->Bottom += y;
    return 0;
}
//---------------------------------------------------------------------------
//Pɕ߂Bil͐Ƃ͌Ȃj
__fastcall OperateRect::Difference(int *x,int *y)
{
    *x = Right-Left;
    *y = Bottom-Top;
    return 0;
}
//---------------------------------------------------------------------------
//̐Βl
__fastcall OperateRect::Width(void)
{
    return abs(Right-Left);
}
//---------------------------------------------------------------------------
//c̐Βl
__fastcall OperateRect::Height(void)
{
    return abs(Bottom-Top);
}
//---------------------------------------------------------------------------
//es{kŏI镶ɂB
//͍̒lĂȂ̂Œ
__fastcall OperateRect::ToString(char *str)
{
    sprintf(str,"%d,%d,%d,%d\r\n",Left,Top,Right,Bottom);
    return 0;
}
//---------------------------------------------------------------------------
//ToString̋tB
__fastcall OperateRect::FromString(char *str)
{
    if(sscanf(str,"%d,%d,%d,%d\r\n",&Left,&Top,&Right,&Bottom)==4)
        return 0;
    else
        return -1;
}
//---------------------------------------------------------------------------
//TRect^璼ڑ
OperateRect OperateRect::operator=(TRect r)
{
    this->Left = r.Left;
    this->Top = r.Top;
    this->Right = r.Right;
    this->Bottom = r.Bottom;
    return (*this);
}
//---------------------------------------------------------------------------
//ZBQ̋`̋ʗ̈
OperateRect OperateRect::operator&(OperateRect r1)
{
    OperateRect r2;

    r2 = *this; //gւ킯ɂ͍sȂ̂ŃRs[
    r1.Normalize();
    r2.Normalize();
    if(r1.Left < r2.Left)
        r1.Left = r2.Left;
    if(r1.Top < r2.Top)
        r1.Top = r2.Top;
    if(r1.Right > r2.Right)
        r1.Right = r2.Right;
    if(r1.Bottom > r2.Bottom)
        r1.Bottom = r2.Bottom;
    return r1;
}
//---------------------------------------------------------------------------
//Ï̓eRs[
__fastcall MapContainer::CopyToBuffer(MapData *Mapp,OperateRect SelRect)
{
    int x,y,w,h;

    SelRect.Normalize();
    ContainRect=SelRect;
    w = SelRect.Width();
    h = SelRect.Height();
    for(y=0; y<=h; y++)
        for(x=0; x<=w;x++)
            Buffer[x][y] = Mapp->Data[SelRect.Left+x][SelRect.Top+y].Graph;
    return 0;
}
//---------------------------------------------------------------------------
//i[ꂽ̈w肳ꂽWɃRs[B
//`Ȃ悤ɃRs[̓K؂ȍW߂B
//Draw=falseȂŸRangePoint^ɂ̂݁B
//܂̏ꍇFieldScreeñ|C^^Kv͂Ȃ
__fastcall MapContainer::PasteFromBuffer(MapData *Mapp,int ax,int ay,
    bool Draw,bool Decide,FieldScreen *Fieldp)
{
    int x,y,w,h,mx,my,ay2,dx;
    int p,q;

    w = ContainRect.Width();
    h = ContainRect.Height();
    if(!Decide)
        Mapp->InitRange();

    ay2 = ay%2;
    if(ay<0)
        ay2 = -ay2;
    dx = (ContainRect.Top%2 != ay2); //W̋̈v
    for(y=0; y<=h; y++){
        my = ay+y;
        if(my<0 || my>=Mapp->Height)
            continue;
        for(x=0; x<=w;x++){
            if(my%2)
                mx = ax+x+dx;
            else
                mx = ax+x;
            if(mx<0 || mx>=Mapp->Width)
                continue;
            if(Draw){
                if(Decide)
                    Fieldp->MapChipSet(Mapp,mx,my,Buffer[x][y]);
                else{
                    Fieldp->XY_MapToPhy(mx,my,&p,&q);
                    Fieldp->MapChipPut(p,q,Buffer[x][y]);
                }
            }
            else //̏łRangePoint2Ƃi`̂߁j
                Mapp->RangePoint[mx][my] = 1+(x==0 || x==w || y==0 || y==h);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//Ww肵ȂΌ̏ꏊɓ\
__fastcall MapContainer::PasteFromBuffer(MapData *Mapp)
{
    PasteFromBuffer(Mapp, ContainRect.Left, ContainRect.Top,false,false,NULL);
    return 0;
}
//---------------------------------------------------------------------------
//Nbv{[hɃRs[
__fastcall MapContainer::CopyToClipboard(void)
{
    TClipboard *Clip = new TClipboard();
    AnsiString Str;
    char s[50];
    int x,y;

    Str = CLIPBOARDHEAD;
    Str += "\r\n";
    ContainRect.ToString(s);
    Str += s;

    for(y=0;y<=ContainRect.Height();y++)
        for(x=0;x<=ContainRect.Width();x++){
            Str += itoa(Buffer[x][y],s,16);
            Str += "\r\n";
        }

    Clip->SetTextBuf(Str.c_str());

    delete Clip;
    return 0;
}
//---------------------------------------------------------------------------
//Nbv{[hǂݍ
__fastcall MapContainer::PasteFromClipboard(void)
{
    TClipboard *Clip = new TClipboard();
    AnsiString Str;
    char s[50];
    int x,y,i;

    Str = Clip->AsText;
    i = Str.Pos("\n")-2;
    if(i == (sizeof CLIPBOARDHEAD)-1){
        strncpy(s,Str.c_str(),i);
        s[i]='\0';
        if(strcmp(s,CLIPBOARDHEAD))
            return -1;
    }
    else
        return -1;
    Str.Delete(1,Str.Pos("\n"));
    if(ContainRect.FromString(Str.c_str())==-1)
        ShowMessage("Nbv{[h̓ǂݍ݃G[");
    Str.Delete(1,Str.Pos("\n"));
    for(y=0;y<=ContainRect.Height();y++)
        for(x=0;x<=ContainRect.Width();x++){
            sscanf(Str.c_str(),"%x",&Buffer[x][y]);
            Str.Delete(1,Str.Pos("\n"));
        }
    delete Clip;
    return 0;
}
//---------------------------------------------------------------------------

