//---------------------------------------------------------------------------
#ifndef gbwedit1H
#define gbwedit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <DBCtrls.hpp>
#include <ExtCtrls.hpp>
#include <stdlib.h>
#include "cgauges.h"
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <Buttons.hpp>
#include "gbwfield.h"
#include <ComCtrls.hpp>
#define CLIPBOARDHEAD "GBW-Map ClipBoard Format"
#define MAPXPANEL 0
#define MAPYPANEL 1
#define NAVIGATEPANEL 2
#define RIGHTSPACE 192

#define MODE_DRAWGROUND 0
#define MODE_DRAWUNIT   1
#define DGMODE_PEN       0
#define DGMODE_BOXFILL   1
#define DGMODE_BOXSELECT 2

#define NAVIGATEGROUND "n`ҏWF}bv̒n`߂܂B"
#define NAVIGATEUNIT "jbgzuF}bvɃjbgzu܂B"
#define NAVIGATERANGE "jbgNbNƎ˒͈͂\܂B"
#define NAVIGATERANGENOW "˒͈͕\"

#define GRAPHFILE "gwgrp.bmp"
#define GRAPHFILE16 "gwgrp16.bmp"
#define NEWFILENAME "newfile.map"
#define UNITFILE "gbwunit.dat"

class SystemStatus;
//---------------------------------------------------------------------------
class OperateRect : public TRect
{
private:
public:
    OperateRect(void){
        NoSelect();
    }
    OperateRect(TRect r){
        *this = r;
    }
    __fastcall NoSelect(void);
    __fastcall SelectAreaFirst(int,int,int,int);
    __fastcall SelectAreaSecond(int,int);
    __fastcall AreaSelected(void);
    __fastcall GetSelectedArea(TRect *);
    __fastcall Normalize(void);
    __fastcall Move(int,int);
    __fastcall Difference(int *,int *);
    __fastcall Width(void);
    __fastcall Height(void);
    __fastcall ToString(char *);
    __fastcall FromString(char *);
    operator TRect(void){
         return Rect(Left,Top,Right,Bottom);
    }
    OperateRect operator=(TRect);
    OperateRect operator&(OperateRect);
    OperateRect operator&=(OperateRect r){
         return (*this & r);
    }
};
//---------------------------------------------------------------------------
//}bvf[^̈ꕔi[
class MapContainer
{
private:
public:
    OperateRect ContainRect; //Rs[̋`̈
    int Buffer[MAPWIDTHMAX][MAPHEIGHTMAX];
    MapContainer(void){
        ContainRect.NoSelect();
    }
    __fastcall CopyToBuffer(MapData *,OperateRect);
    __fastcall PasteFromBuffer(MapData *,int,int,bool,bool,FieldScreen *);
    __fastcall PasteFromBuffer(MapData *);
    __fastcall CopyToClipboard(void);
    __fastcall PasteFromClipboard(void);
};
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE Ǘ̃R|[lgvoid __fastcall FormCreate(TObject *Sender);
    TMainMenu *MainMenu1;
    TMenuItem *MI_File;
    TMenuItem *MI_Exit;
    TMenuItem *N1;
    TMenuItem *MI_SaveAs;
    TMenuItem *MI_Save;
    TMenuItem *MI_Open;
    TListBox *ListBox1;
    TPanel *Panel1;
    TScrollBox *ScrollBox1;
    TImage *Image1;
    TMenuItem *MI_Edit;
    TMenuItem *MI_Undo;
    TMenuItem *MI_Property;
    TOpenDialog *OpenDialog1;
    TSaveDialog *SaveDialog1;
    TMenuItem *MI_Help;
    TMenuItem *MI_Version;
    TPanel *Panel2;
    TSpeedButton *SpeedButton_Open;
    TSpeedButton *SpeedButton_Save;
    TSpeedButton *SpeedButton_SaveAs;
    TSpeedButton *SpeedButton_Property;
    TSpeedButton *SpeedButton_Undo;
    TPanel *Panel3;
    TSpeedButton *SpeedButton_GraphNormal;
    TSpeedButton *SpeedButton_GraphSmall;
    TMenuItem *MI_Option;
    TMenuItem *MI_GraphSmall;
    TMenuItem *MI_GraphNormal;
    TMenuItem *N2;
    TPanel *Panel4;
    TSpeedButton *SpeedButton_DrawGround;
    TSpeedButton *SpeedButton_DrawUnit;
    TStatusBar *StatusBar1;
    TMenuItem *MI_Tool;
    TMenuItem *MI_DrawGround;
    TMenuItem *MI_Edit_BoxSelect;
    TMenuItem *MI_Edit_BoxFill;
    TMenuItem *MI_Edit_Pen;
    TMenuItem *MI_DrawUnit;
    TMenuItem *MI_Copy;
    TMenuItem *MI_Paste;
    TPanel *Panel5;
    TSpeedButton *SpeedButton_Pen;
    TSpeedButton *SpeedButton_BoxFill;
    TSpeedButton *SpeedButton_BoxSelect;
    TImage *Image_UnitStatus;
    TImage *Image_GroundStatus;
    TImage *Image_PenStatus;
    void __fastcall OnForm1Paint(TObject *Sender);

    void __fastcall OnForm1Resize(TObject *Sender);

    void __fastcall OnForm1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall OnList1DrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
    void __fastcall OnImage1MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall MI_OpenClick(TObject *Sender);
    void __fastcall MI_SaveClick(TObject *Sender);
    void __fastcall MI_SaveAsClick(TObject *Sender);
    void __fastcall OnImage1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall OnImage1MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall MI_UndoClick(TObject *Sender);
    void __fastcall MI_PropertyClick(TObject *Sender);
    void __fastcall MI_ExitClick(TObject *Sender);
    void __fastcall OnListBox1MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall OnForm1Close(TObject *Sender, TCloseAction &Action);
    void __fastcall MI_VersionClick(TObject *Sender);
    void __fastcall GraphNormalClick(TObject *Sender);
    void __fastcall GraphSmallClick(TObject *Sender);
    void __fastcall MenuGraphNormalClick(TObject *Sender);
    void __fastcall MenuGraphSmallClick(TObject *Sender);
    void __fastcall DrawGroundClick(TObject *Sender);
    void __fastcall MI_DrawUnitClick(TObject *Sender);

    void __fastcall MI_Edit_PenClick(TObject *Sender);
    void __fastcall MI_Edit_BoxFillClick(TObject *Sender);
    void __fastcall MI_Edit_BoxSelectClick(TObject *Sender);
    void __fastcall MI_CopyClick(TObject *Sender);
    void __fastcall MI_PasteClick(TObject *Sender);
    void __fastcall OnForm1Show(TObject *Sender);
private:	// [U[錾
    MapData *Map1,*MapBackup;
    FieldScreen *FieldScreen1;
    GBWImageData *GBWImage1;
    BaseData *BaseData1;
    SideStatus *SideStatus1[2]; //vZ̈
    GamePurposes *Purposes1[2];
    SystemStatus *System1;
    TGBWOption Option;
    //OpenGBWMapDialog *OpenMapDialog;
    OperateRect SelectedRect;
    OperateRect DragRect;
    MapContainer Container;
    bool NowRunning;
    int PanelX,PanelY;
    __fastcall ScreenPut(void);
    __fastcall ImageLoad(void);
    __fastcall ScreenRevise(int,int,int,int);
    __fastcall ScreenRevise(TRect);
    __fastcall ScreenReviseBlock(int,int);
    __fastcall SaveMap(char *);
    __fastcall LoadMap(char *);
    __fastcall LoadMapBinary(char *);
    __fastcall SaveNameDialog(void);
    __fastcall ModifiedSaveDialog(void);
    __fastcall MapModifiedCheck(void);
    __fastcall MapSizeSet(void);
    __fastcall CheckOutOfMap(void);
    __fastcall EditorAllUnitPut(void);
    __fastcall PenStatusPut(void);
    __fastcall PenStatusPut_Ground(int);
    __fastcall PenStatusPut_Unit(int);
    __fastcall PenLeftDown(int,int);
    __fastcall PenLeftDrag(int,int);
    __fastcall PenLeftUp(int,int);
    __fastcall PenRightDown(int,int);
    __fastcall PenMove(int,int);
    __fastcall DrawBoxSelect(OperateRect,bool,bool);
    __fastcall MapChipWrite(int,int,int);
    __fastcall WriteSelectedMapChip(int);
    __fastcall EndBoxSelect(bool);
    __fastcall CopySelectedMapChip(bool);
    __fastcall UnitWrite(int,int,int);
    __fastcall UnitDelete(int,int);
    __fastcall MapChipStatusPut(int,int);
    __fastcall StartGroundEdit(void);
    __fastcall StartUnitEdit(void);
    __fastcall StartPenMode(void);
    __fastcall StartBoxFillMode(void);
    __fastcall StartBoxSelectMode(void);
    __fastcall ChangeNavigateMessage(int,int);
    __fastcall OpenEnabled(bool);
    __fastcall SaveEnabled(bool);
    __fastcall SaveAsEnabled(bool);
    __fastcall PropertyEnabled(bool);
    __fastcall UndoEnabled(bool);
public:		// [U[錾
    __fastcall TForm1(TComponent* Owner);
    __fastcall ~TForm1(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
class SystemStatus
{
private:
public:
    bool LeftButton;
    bool RightButton;
    bool MapModified;
    bool ShowRange;
//    bool ShowVisible;
    bool SelectDecided;
    bool NowDragging;
    char EditFile[256];
    int DrawMode;       //n`ҏWjbgzu
    int DrawGroundMode; //n`ҏW̕`惂[h
    int PenNumber;
//    int SeizedX; //hbOׂɒ͂񂾓_
//    int SeizedY;
    SystemStatus(void){
        LeftButton=RightButton=false;
        MapModified=false;
        ShowRange=false;
        SelectDecided=false;
        NowDragging=false;
        strcpy(EditFile,NEWFILENAME);
        DrawMode = MODE_DRAWGROUND;
        DrawGroundMode = DGMODE_PEN;
        PenNumber=0;
    }
//    __fastcall NoSelect(void);
//    __fastcall SelectAreaFirst(int,int,int,int);
//    __fastcall SelectAreaSecond(int,int);
//    __fastcall AreaSelected(void);
//    __fastcall GetSelectedArea(TRect *);
//    __fastcall SeizeArea(int,int);
};
//---------------------------------------------------------------------------
#endif
